using System;
using System.Windows.Forms;

namespace Skii.Action
{
	/// <summary>
	/// BaseAction ժҪ˵
	/// </summary>
	public abstract class BaseAction
	{
		public BaseAction()
		{
			//
			// TODO: ڴ˴ӹ캯߼
			//
		}

		private int id = 0;
		private string name = null;
		private bool enabled = true;
		private bool isVisible = true;
		private ToolBarButton toolBarButton = null;
		private MenuItem menuItem = null;
		private Button button = null;
		private TreeNode treeNode = null;

		/// <summary>
		/// Ϊ
		/// </summary>
		/// <returns></returns>
		public int GetId() 
		{
			return this.id;
		}

		/// <summary>
		/// Ϊ
		/// </summary>
		/// <param name="id"></param>
		public void SetId(int id) 
		{
			this.id = id;
		}

		/// <summary>
		/// Ϊ
		/// </summary>
		public string GetName()
		{
			return this.name;
		}

		/// <summary>
		/// Ϊ
		/// </summary>
		/// <param name="name"></param>
		public void SetName(string name) 
		{
			this.name = name;
		}

		/// <summary>
		/// ΪǷ
		/// </summary>
		/// <returns></returns>
		public bool IsEnabled()
		{
			return this.enabled;
		}
		
		/// <summary>
		/// ΪǷ
		/// </summary>
		/// <param name="enabled"></param>
		public void SetEnabled(bool enabled)
		{
			this.enabled = enabled;

			//ÿؼ״̬
			if (this.toolBarButton != null) toolBarButton.Enabled = this.enabled;
			if (this.menuItem != null) menuItem.Enabled = this.enabled;
			if (this.button != null) button.Enabled = this.enabled;
			if (this.treeNode != null) 
			{
				if (this.enabled) 
					treeNode.ForeColor = System.Drawing.SystemColors.WindowText;
				else 
					treeNode.ForeColor = System.Drawing.SystemColors.GrayText;
			}
		}

		/// <summary>
		/// ΪǷɼ
		/// </summary>
		/// <returns></returns>
		public bool IsVisible()
		{
			return this.isVisible;
		}

		/// <summary>
		/// ΪǷɼ
		/// </summary>
		/// <param name="visible"></param>
		public void SetVisible(bool visible)
		{
			this.isVisible = visible;

			//ÿؼ״̬
			if (this.toolBarButton != null) toolBarButton.Visible = this.isVisible;
			if (this.menuItem != null) menuItem.Visible = this.isVisible;
			if (this.button != null) button.Visible = this.isVisible;
			if (this.treeNode != null) 
			{
				if (!this.isVisible)
					this.treeNode.Remove();
			}
		}

		/// <summary>
		/// ʼΪ
		/// </summary>
		/// <param name="toolBarButton">ť</param>
		public void Init(ToolBarButton toolBarButton)
		{
			this.toolBarButton = toolBarButton;
			ToolBar toolBar = (ToolBar)(this.toolBarButton.Parent);
			toolBar.ButtonClick += new ToolBarButtonClickEventHandler(BaseAction_ButtonClick);
			toolBarButton.Enabled = this.enabled;
			toolBarButton.Visible = this.isVisible;
		}

		/// <summary>
		/// ʼΪ
		/// </summary>
		/// <param name="menuItem">˵</param>
		public void Init(MenuItem menuItem)
		{
			this.menuItem = menuItem;
			this.menuItem.Click += new EventHandler(menuItem_Click);
			menuItem.Enabled = this.enabled;
			menuItem.Visible = this.isVisible;
		}

		/// <summary>
		/// ʼΪ
		/// </summary>
		/// <param name="button">ť</param>
		public void Init(Button button)
		{
			this.button = button;
			this.button.Click += new EventHandler(button_Click);
			button.Enabled = this.enabled;
			button.Visible = this.isVisible;
		}

		/// <summary>
		/// ʼΪ
		/// </summary>
		/// <param name="treeNode">ڵ</param>
		public void Init(TreeNode treeNode)
		{
			this.treeNode = treeNode;
			this.treeNode.TreeView.AfterSelect += new TreeViewEventHandler(TreeView_AfterSelect);
			if (this.enabled) 
				treeNode.ForeColor = System.Drawing.SystemColors.WindowText;
			else 
				treeNode.ForeColor = System.Drawing.SystemColors.GrayText;
			if (!this.isVisible)
				treeNode.Remove();
		}

		/// <summary>
		/// ִΪ
		/// </summary>
		public virtual void Execute()
		{
		}

		private void BaseAction_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
		{
			if (!enabled || !isVisible) return;
			if (this.toolBarButton == e.Button)
			{
				Execute();
			}
		}

		private void menuItem_Click(object sender, EventArgs e)
		{
			if (!enabled || !isVisible) return;
			Execute();
		}

		private void button_Click(object sender, EventArgs e)
		{
			if (!enabled || !isVisible) return;
			Execute();
		}

		private void TreeView_AfterSelect(object sender, TreeViewEventArgs e)
		{
			if (!enabled || !isVisible) return;
			TreeNode selectedNode = this.treeNode.TreeView.SelectedNode;
			if (this.treeNode.IsSelected)
			{
				Execute();
			}
		}
	}
}
