using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace Skii.View
{
	/// <summary>
	/// BaseView ժҪ˵
	/// </summary>
	public class BaseView : System.Windows.Forms.UserControl
	{
		/// <summary> 
		/// 
		/// </summary>
		private System.ComponentModel.Container components = null;

		public BaseView()
		{
			// õ Windows.Forms ġ
			InitializeComponent();

			// TODO:  InitializeComponent úκγʼ
			this.Change += new ViewChangeHandler(BaseView_Change);
			this.MessageOut += new ViewMessageHandler(BaseView_MessageOut);
		}

		/// <summary> 
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region ɵĴ
		/// <summary> 
		/// ֧ķ - Ҫʹô༭ 
		/// ޸Ĵ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// View
			// 
			this.Name = "View";
			this.Size = new System.Drawing.Size(8, 8);

		}
		#endregion

		private Hashtable attributes = new Hashtable();

		/// <summary>
		/// ͼ
		/// </summary>
		public object GetAttribute(string key)
		{
			try 
			{
				return this.attributes[key];
			}
			catch
			{
				return null;
			}
		}

		/// <summary>
		/// ͼ
		/// </summary>
		/// <param name="key"></param>
		/// <param name="valuee"></param>
		public void SetAttribute(string key, object valuee)
		{
			try 
			{
				this.attributes.Remove(key);
			}
			catch {}
			this.attributes.Add(key, valuee);
		}

		/// <summary>
		/// е
		/// </summary>
		public void ClearAttributes() 
		{
			this.attributes.Clear();
		}

		private int id = 0;

		/// <summary>
		/// ͼ
		/// </summary>
		public int GetId()
		{
			return  this.id;
		}

		/// <summary>
		/// ͼ
		/// </summary>
		/// <param name="id"></param>
		public void SetId(int id) 
		{
			this.id = id;
		}

		private string name = null;

		/// <summary>
		/// ͼ
		/// </summary>
		public string GetName()
		{
			return this.name;
		}

		/// <summary>
		/// ͼ
		/// </summary>
		/// <param name="name"></param>
		public void SetName(string name) 
		{
			this.name = name;
		}

		/// <summary>
		/// Ըͼ
		/// </summary>
		public virtual void UpdateView() 
		{
		}

		/// <summary>
		/// ͼ
		/// </summary>
		public virtual void UpdateAttributes()
		{
		}

		/// <summary>
		/// 仯
		/// </summary>
		public event ViewChangeHandler Change;

		public void RaiseChangeEvent()
		{
			Change(this, null);
		}

		/// <summary>
		/// Ϣ
		/// </summary>
		public event ViewMessageHandler MessageOut;

		public void RaiseMessageOutEvent(string message)
		{
			MessageOut(this, message);
		}

		private void BaseView_Change(BaseView view, EventArgs e)
		{
		}

		private void BaseView_MessageOut(BaseView view, string message)
		{
		}
	}

	public delegate void ViewChangeHandler(BaseView view, EventArgs e);
	public delegate void ViewMessageHandler(BaseView view, string message);
}
